/******************************************************************************
 *  Name:
 *  NetID:
 *  Precept:
 *
 *  Description: Calculate Largest Common Number
 *
 *               Given an NxN matrix of integers, find the largest number that 
 *               appears (at least) once in each row (or report that no such 
 *               number exists)
 *
 *               You just need to fill in all the TODO
 *
 *  Debugging: To help you in debugging we have provided toString() method
 *               that you can call easily
 *
 *  Helper File: LCNTools.java has been provided to you with lot of helper 
 *               methods to test, log etc
 *
 *               You don't need to know anything about this file
 *
 *               ALSO PLEASE DON'T MAKE ANY CHANGES TO LCNTools.java
 *
 *               Logging feature is to help us in grading 
 *               It automatically creates logs directory and logs.zip,
 *               you don't have to do anything
 *
 * Testing: We have provided few testcases for you (LCNTools.test() in main())
 *               that checks for correctness on few given input .txt files
 *               and also timing
 *
 * Additional Tests: If you want to create more testcases, you could create
 *               .txt file in the example format:
 *
 *               3
 *               4 5 6
 *               3 4 5
 *               2 3 4
 *
 *               Then you could call LCNTools.test("example.txt", 4, true)
 *               4 and true indicate the correct answer for the given file
 *               for solution() and isASolution() methods
 *
 * Compile:
 *             javac-algs4 LCNTools.java
 *                 (PLEASE COMPILE LCNTools.java first)
 *
 *             javac-algs4 LCN.java
 *
 * Execute: 
 *             java-algs4 LCN
 *
 ******************************************************************************/

// TODO: FILL IN YOUR IMPORTS HERE

public class LCN {

    public final int n; // size of the board
    public final int[][] board; // copy of the board

    private int result = Integer.MIN_VALUE; // result
    private boolean found; // If a solution exists

    // initial board position, based on given tiles
    public LCN(int[][] tiles) {

        this.n = tiles.length;
        this.board = new int[n][n];
        for (int i = 0; i < n; i++) { // fill the board from input
            for (int j = 0; j < n; j++)
                board[i][j] = tiles[i][j];
        }
    
        // TODO: YOUR CODE HERE
                
    }

    // return the LCN if found, Integer.MIN_VALUE otherwise
    public int solution() {

        // TODO: YOUR CODE HERE
        
    }

    // return true if there existed a number on every row
    public boolean isASolution() {

        // TODO: YOUR CODE HERE
        
    }

    // return a string representation of the LCN
    public String toString() {
        // Use the (provided) pretty printer.
        return LCNTools.toString(this);
    }

   /***********************************************************************
    * Test routine.
    **********************************************************************/

    // Main
    public static void main(String[] args) {

        // PLEASE DON"T MAKE ANY CHANGES TO THE BELOW LINE
        LCNTools.logFile();

        // =========
        // Our Tests
        // =========

        LCNTools.test();

        // ================================
        // Your own tests below? (optional)
        // ================================

        // Example format:
        // LCNTools.test("example.txt", 4, true);
 
        // TODO

    }

}
